VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMulDecode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Decode mul project by Fallout (roman3k@mail.ru)"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ************************************* '
' *Create by Fallout (roman3k@mail.ru)* '
' *     Do not remove this header     * '
' ************************************* '
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type tChar
    xWidth As Byte
    yHeight As Byte
    Unk As Byte
    sData() As Integer
End Type

Private Type tFont
    CharList(0 To 224 - 1) As tChar
End Type

Private FontList(9) As tFont

Private hDCTmp As Long
Private hBMTmp As Long
Private hBrush As Long

Private X As Integer, Y As Integer
Private i As Integer, n As Integer

Private mWidth As Integer
Private mHeight As Integer

Private mvarFilePath As String
Private FontIs As Byte

Public Property Let SetFont(ByVal vData As Byte)
    FontIs = vData
End Property

Public Property Get SetFont() As Byte
     SetFont = FontIs
End Property

Public Property Let FilePath(ByVal vData As String)
    mvarFilePath = vData
End Property

Public Property Get FilePath() As String
    FilePath = mvarFilePath
End Property

Public Property Get WidhtInfo() As Integer
    WidhtInfo = mWidth
End Property

Public Property Get HeightInfo() As Integer
    HeightInfo = mHeight
End Property

Private Sub Clear_Dc()
    DeleteDC hDCTmp                ' clean up '
    DeleteObject hBMTmp
End Sub

Public Function Load_Fonts() As Boolean
    Dim fileNum As Integer, Unknown As Byte
    Dim antiOverLow As Integer
    On Error GoTo load_is_fail
    Load_Fonts = False
    fileNum = FreeFile()
    Open mvarFilePath For Binary Access Read As fileNum
    For i = 0 To 9
        Get fileNum, Seek(fileNum), Unknown
        For n = 0 To 223
            With FontList(i).CharList(n)
                Get fileNum, Seek(fileNum), .xWidth
                Get fileNum, Seek(fileNum), .yHeight
                Get fileNum, Seek(fileNum), .Unk
                antiOverLow = .yHeight
                antiOverLow = (antiOverLow * .xWidth - 1)
                ReDim .sData(antiOverLow)
                Get fileNum, Seek(fileNum), .sData()
            End With
        Next n
    Next i
    Close fileNum
    Load_Fonts = True
    Exit Function
load_is_fail:
    Load_Fonts = False
End Function

Public Sub DrawSymbol(ByRef picHdc As Long, ByVal charID As Byte)
    Dim r As RECT
    Y = 0: X = 0: i = 0
    mWidth = FontList(FontIs).CharList(charID).xWidth
    mHeight = FontList(FontIs).CharList(charID).yHeight
    ' create memory pool '
    hDCTmp = CreateCompatibleDC(GetDC(0))                        ' create a device context                   '
    hBMTmp = CreateCompatibleBitmap(GetDC(0), mWidth, mHeight)   ' create a bitmap                           '
    SelectObject hDCTmp, hBMTmp                                  ' select the bitmap into the device context '
    SetRect r, 0, 0, mWidth, mHeight                             ' set the rectangle's values                '
    hBrush = CreateSolidBrush(vbGreen)                           '                                           '
    FillRect hDCTmp, r, hBrush                                   ' fill the rect with the your color         '
    DeleteObject hBrush                                          ' delete our brush                          '
' end create '
    Do While Y < mHeight
        For X = 0 To mWidth - 1
            Call SetPixel(hDCTmp, X, Y, Color16To32(FontList(FontIs).CharList(charID).sData(i)))
            i = i + 1
        Next X
        Y = Y + 1
    Loop
    picHdc = hDCTmp
End Sub

Private Sub Class_Initialize()
    FontIs = 0
End Sub

Private Sub Class_Terminate()
    Clear_Dc
End Sub

Private Function Color16To32(color16 As Integer) As Long   '  16   32   '
    Color16To32 = RGB(((((color16 And &H7C00) / &H400) / &H1F) * &HFF), ((((color16 And &H3E0) / &H20) / &H1F) * &HFF), (((color16 And &H1F) / &H1F) * &HFF))
End Function
